function G=joga_velha(Q,heu);
% Funo que executa o jogo da velha
% 
% Chamada com os parametros definidos em jvelha.m
   global Param;
   % Limpa a figura para a prxima jogada
   figure(gcf); hold off;
   for i=0:3; plot([0 3],[i i],'b'); hold on; end;
   for i=0:3; plot([i i],[0 3],'b'); end;
   axis equal; axis([0 3 0 3]);
   set(gca,'XTick',[],'XTickLabel',[]);
   set(gca,'YTick',[],'YTickLabel',[]);
   %text(-0.2,-0.2,'EXIT')
   if Q==1; tit1='Jogador Comea'; end
   if Q==2; tit1='Computador Comea'; end;
   if heu==0; tit2='       Heurstica: Aleatria';
   elseif  heu==1; tit2='       Heurstica: Dif.Alinhamentos';
   else; tit2='       Heurstica: Alinhamentos Futuros'; end;
   title(strcat(tit1,tit2));
   % Chama o jogo: Indica quem comea e a heurstica utilizada
   G=jogar(Q-1,heu);
   set(Param,'enable','on');
% Fim do jogo
%========================================================================================
function G=jogar(Qini,heu);                          % Funo que gerencia o jogo
   global hb1 hb2;
   A=zeros(3,3);                                     % Inicializa matriz A -> Mapa do jogo
   Xmouse=9;Ymouse=9;                                % Inicializa variveis para entrar no loop
   npoints=0;                                        % Nmero de quadros preenchidos -> mx = 9
   G=0;                                              % Jogador que ganhou: Comput=1, Jog=-1
   while (Ymouse*Xmouse>0) & npoints<9;              % Loop enquanto condio final no for satisfeita
      G=ganhou(A,npoints);                           % Verifica se alguem j ganhou e indica em G
      if abs(G); npoints=9;                           % Alguem j ganhou, fora fim do jogo
      else
         if ~rem(npoints-Qini,2)                     % Jogada do Adversrio
            xlabel('VEZ DO JOGADOR','Color','red');
            [Xmouse,Ymouse]=ginput(1);               % Entra jogada pelo mouse
            Xmouse=ceil(Xmouse);
            Ymouse=ceil(Ymouse);
            if (1 <= Xmouse) & (Xmouse <= 3) & (1 <= Ymouse) & (Ymouse <= 3);  % Quadro vlido
               if A(Xmouse,Ymouse) == 0              % Quadro vazio
                  A(Xmouse,Ymouse)=-1;               % Marca como quadro do Jogador
                  circle(Xmouse-0.5,Ymouse-0.5,0.25);% Ponto central do quadro selecionado
                  npoints=npoints+1;                 % Totalizador dos quadros preenchidos
               end;
            end;
         else                                        % Jogada do COMPUTADOR
            xlabel('VEZ DO COMPUTADOR .... AGUARDE!!!','Color','red');
            pause(0.001);                            % So para atualizar a tela
            [A,sim]=vai_pensar(A,npoints,heu);       % Verifica se tem algo para pensar nesta jogada
            if sim
                A=joga_pc(A,npoints,heu);            % Funo para execuo da jogada
            end;  
            npoints=npoints+1;
         end;
      end;
   end;
   G=ganhou(A,npoints);
   if abs(G);                            % Alguem ganhou -> G diferente de zero
      if G>0;
         xlabel('O Computador  o vencedor !!!','Color','red');
      else;
         xlabel('Parabns ! Voc ganhou !!!','Color','red');
      end;
   else;
      if npoints==9;
         xlabel('EMPATAMOS...','Color','red');
      else;
         xlabel('Jogo encerrado!!!','Color','red');
      end;
   end;
% Fim da funo JOGAR.M
%==========================================================================================
% Funo para desenvolvimento de regras para o computador executar a jogada
% Recebe matriz A e Num da jogada em que estamos
%
% OBS: Quando entra nesta rotina j  seguro que no h jogada do computador que
% ganhe de imediato (encerre o jogo) assim como no h como o adversrio ganhar nesta jogada
% de fato, esta funo deve preocupar-se apenas com a heurstica proposta e aplica MIN-MAX
function A=joga_pc(A,npoints,heu);                  
nivel=1;
NJ=9-npoints;                           % Nmero de jogadas restantes para encerrar o jogo
% =====================================   Analisa cada possvel jogada do Computador
AvalMax=zeros(1,NJ);                    % Matriz que armazena resultado da heurstica
for Jc=1:NJ                             % Quantas jogadas ainda so possiveis
   Xk=monta_jogada(A,Jc,1,0);           % Monta matriz de cada possivel jogada do computador no instante K
   AvalMax(1,Jc)=heuristica(heu,Xk,NJ); % Verifica heurstica
end
Jogada1=Pavaliar(AvalMax,1);            % Retorna jogadas avaliadas pelo MAXIMO
% =====================================   Analisa cada possvel jogada do Adversrio
AvalMin=zeros(NJ,NJ-1);                 % Matriz que armazena resultado da heurstica
for Jc=1:NJ                             % Quantas jogadas ainda so possiveis
   if Jogada1(Jc)                       % Se for uma jogada que deve ser avaliada
      Xk=monta_jogada(A,Jc,1,0);        % Monta matriz de cada possivel jogada do computador no instante K
      for Ja=1:NJ-1                     % Analisa possveis jogadas do adversrio para a jogada Xk
         Xka=monta_jogada(Xk,Ja,-1,0);  % Monta matriz de possiveis jogadas do adversrio no instante K
         AvalMin(Jc,Ja)=heuristica(heu,Xka,NJ);  % Verifica heurstica
      end
   else
      AvalMin(Jc,:)=100;                % Jogada descartada
   end
end
Jogada2=Pavaliar(AvalMin,0);            % Retorna jogadas avaliadas pelo MINIMO
% =====================================   Seleciona Jogada
achou=0;
for Jc=1:NJ
   for Ja=1:NJ-1
      if Jogada2(Jc,Ja) & ~achou
         A=monta_jogada(A,Jc,1,1);      % Atualiza jogada na matriz A com a jogada selecionada
         achou=1;                       % Fora saida do loop
      end
   end
end
% Fim da funo JOGA_PC.M
%==========================================================================================
%==========================================================================================
% FUNES DE IMPLEMENTAO DAS HEURSTICAS PROPOSTAS
%
%==========================================================================================
function N=heuristica(heu,M,NJ);        % Realiza funo de heurstica selecionada
if heu==0 N=rand(1); end;               % Sem Heurstica  -> Aleatria
if heu>=1 N=dif_alin(M); end;           % Heurstica = Diferena entre nmero de alinhamentos
%if heu==2 N=NumGanha(M,NJ); end;       % Heurstica = Nmero de chances para fechar na prx. jogada
%==========================================================================================
function N=dif_alin(X);  % Calcula a diferena de alinhamentos entre jogadores
Xj=X;                                         % Inicializa matriz do Jogador Adversrio
Xc=X;                                         % Inicializa matriz do Computador
Nj=0; Nc=0;                                   % Inicializa nmero de alinhamentos dos jogadores 
for i=1:3
   for j=1:3
      if X(i,j)==0                            % Quadro em branco -> possibilidade de jogada
         Xj(i,j)=-1;                          % Admite que  do Adversrio          
         Xc(i,j)=1;                           % Admite que  do Computador
      end
   end
end
for i=1:3
   if sum(Xj(i,:))==-3  Nj=Nj+1;  end;        % Verifica se h alinhamento do adversrio na linha
   if sum(Xc(i,:))== 3  Nc=Nc+1;  end;        % Verifica se h alinhamento do computador na linha
   if sum(Xj(:,i))==-3  Nj=Nj+1;  end;        % Verifica se h alinhamento do adversrio na coluna
   if sum(Xc(:,i))== 3  Nc=Nc+1;  end;        % Verifica se h alinhamento do computador na coluna
end
if (Xj(1,1)+Xj(2,2)+Xj(3,3))==-3 Nj=Nj+1;  end;  % Alinhamento do jogador na diagonal 1
if (Xc(1,1)+Xc(2,2)+Xc(3,3))== 3 Nc=Nc+1;  end;  % Alinhamento do computador na diagonal 1
if (Xj(3,1)+Xj(2,2)+Xj(1,3))==-3 Nj=Nj+1;  end;  % Alinhamento do jogador na diagonal 2
if (Xc(3,1)+Xc(2,2)+Xc(1,3))== 3 Nc=Nc+1;  end;  % Alinhamento do computador na diagonal 2
N=Nc-Nj;
%==========================================================================================
%function N=NumGanha(X,NJ);  % Calcula a diferena entre as chances de ganhar na prx. Jogada
%Nj=0; Nc=0;                 % Inicializa nmero de chances dos jogadores 
%Qbco=0;                     % Contador de quadros em branco
%for i=1:3
%   for j=1:3
%      if X(i,j)==0 & Qbco<NJ                  % Quadro em branco -> possibilidade de jogada
%         Qbco=Qbco+1;                         % Incrementa num de quadros em branco
%         Xj=X;                                % Inicializa matriz do Jogador Adversrio
%         Xj(i,j)=-1;                          % Admite que posio  do Adversrio
%         Xk=monta_jogada(Xj,Qbco+1,-1,0);     % Monta matriz de cada futura jogada do adversrio
%         if vai_ganhar(-1,Xk,0) Nj=Nj+1; end; % Chance do adversrio ganhar
%         Xc=X;                                % Inicializa matriz do Computador
%         Xc(i,j)=1;                           % Admite que posio  do Computador
%         Xk=monta_jogada(Xc,Qbco+1,1,0);      % Monta matriz de cada futura jogada do computador
%         if vai_ganhar(1,Xk,0) Nc=Nc+1; end;  % Chance do computador ganhar
%      end
%   end
%end
%N=Nc-Nj;
%==========================================================================================
%==========================================================================================
%==========================================================================================
% UTILITARIOS DE USO GERAL
%
%==========================================================================================
function [A,sim]=vai_pensar(A,np,heu);    
% Verifica se tem algo para pensar nesta jogada, ou seja, so respostas para a qual
% no precisa processamento do nmero de alinhamentos.
% J retorna a matriz A atualizada e tabuleiro marcado
corx='b';                            % Cor AZUL, indica jogada no automtico, sem pensar
if (np<=1)                           % Primeira jogada do computador
  if A(2,2)==0                       % Se adversrio no saiu pelo centro -> ento saia
     A(2,2)=1;                       % Marca na matriz A
     marca_x(2,2,corx);              % Marca X no tabuleiro
  else                               % O adversrio saiu pelo centro
     A(1,1)=1;                       % Marca na diagonal
     marca_x(1,1,corx);              % Sai pela diagonal
  end
  vai=1;                             % Indica que vai jogar sem pensar
else                                 % No  a primeira jogada do computador
   [vai,A]=vai_ganhar(1,A,1);        % Verifica se existe chance de fechar alinhamento -> FECHA
   if ~vai                           % Se no pode ganhar nessa, verifica se o adversrio pode
      [vai,A]=vai_ganhar(-1,A,1);    % Verifica se existe chance do adversrio alinhar -> ELIMINA
   end
end

if (np==8)                           %  a ltima jogada e  do computador
   for i=1:3
      for j=1:3
         if A(i,j)==0
            A(i,j)=1;
            marca_x(i,j,corx);       % No tem o que pensar... joga
            vai=1;
         end
      end
   end
end   
% =============  CASOS ESPECIAIS  ===========================
corx='g';                            % Cor VERDE, indica jogada protegida por CASO ESPECIAL
% ===========  Para heurstica de Dif. Alinhamentos e Aleatria ===========================
if A(2,2)==1 & np==3 & heu~=2        
   if (A(1,1)==-1 & A(3,3)==-1)  | (A(3,1)==-1 & A(1,3)==-1)  
      A(2,1)=1;
      marca_x(2,1,corx);                    
      vai=1;
   end
   if A(3,1)==-1 & A(2,3)==-1
      A(3,3)=1;
      marca_x(3,3,corx);                    
      vai=1;
   end
end;
% ===========  Para heurstica de Aleatria ==============================================
if A(2,2)==-1 & A(3,3)==-1 & A(1,1)==1 & np==3 & heu==0; 
   % Apenas para a heurstica Aleatria
   A(3,1)=1;
   marca_x(3,1,corx);                    
   vai=1;
end;
sim=~vai;                           % Retorna a nova matriz A e indica que no vai fazer nada-> tem de pensar
% Fim da funo VAI_PENSAR.M
%=============================================================
function M=monta_jogada(A,Jc,Jogador,marca);
% Retorna na matriz M a jogada de nmero Jc do JOGADOR
% A contagem das jogadas corre da esquerda para a direta, de cima para baixo, nos quadros
% que ainda no foram preenchidos
M=A;                                          % Inicializa a matriz com o estado atual
c=0;                                          % Contador de quadros em branco
for i=1:3
   for j=1:3
      if A(i,j)==0 c=c+1;                     % Quadro em branco -> possibilidade de jogada
         if Jc==c                             % Jogada possvel que esta procurando
            M(i,j)=Jogador;                   % Simula a jogada para o jogador que pediu
            if marca                          % Se for para marcar
               marca_x(i,j,'r');              % Cor VERMELHA, indica jogada pela heurstica
            end;                              
         end
      end
   end
end
%=============================================================
function J=Pavaliar(M,Max);
% Avalia a matriz procurando jogadas de MAX ou MIN
  if Max fcao='max';
  else fcao='min'; end;                        % Seleciona funco que ser utilizada
  Valor=feval(fcao,M);                         % Procura valor numrico do MAX/MIN
  Valor=feval(fcao,Valor);                     % Encontra valor do MAX/MIN
  J=(M-Valor==0);                              % Matriz de 1 e 0 indicando onde esta o MIN/MAX
%=============================================================
function resp=ganhou(A,npoints);
% Funo para verificar se alguem j ganhou, ou seja,
% Se j houve um alinhamento completo da matriz A
resp = 0;
LW=5; %LineWidth does not change for line type "--"
   for i=1:3
       if abs(sum(A(i,:)))==3;
          plot([i-0.5 i-0.5],[0 3],'r--','LineWidth',LW);
          resp=sum(A(i,:))/3 ;
       end;
       if abs(sum(A(:,i)))==3;  
          plot([0 3],[i-0.5 i-0.5],'r--','LineWidth',LW); 
          resp=sum(A(:,i))/3 ;
       end;
   end;
   
   soma=A(1,1)+A(2,2)+A(3,3);
   if abs(soma)==3; 
      plot([0 3],[0 3],'r--','LineWidth',LW);  
      resp=soma/3;
   end; % Diagonal 1
   soma=A(3,1)+A(2,2)+A(1,3);
   if abs(soma)==3;
      plot([0 3],[3 0],'r--','LineWidth',LW);
      resp=soma/3;
   end; % Diagonal 2
   
%=============================================================
function [pode,MA]=vai_ganhar(J,A,encerra);
% Funo para verificar se existe chance do jogador J alinhar por completo - ganhar
   MA=A;                                  % Estado inicial - > No marca nada
   corx='b';
   col=0; lin=0;
   for i=1:3
      if abs(sum(A(i,:))+J)==3;           % Verifica se h chance nesta linha
         [vv,col]=max(A(i,:)==0);         % Verifica coluna que no foi marcada
         lin=i;
     end
     if abs(sum(A(:,i))+J)==3;            % Verifica se h chance nesta coluna
         [vv,lin]=max(A(:,i)==0);         % Verifica linha que no foi marcada
         col=i;
    end
   end
   if abs(A(1,1)+A(2,2)+A(3,3)+J)==3;     % Verifica se tem chance nesta diagonal
      [vv,col]=max([A(1,1) A(2,2) A(3,3)]==0); % Verifica quadro que no foi marcado
      lin=col;
   end
   if abs(A(3,1)+A(2,2)+A(1,3)+J)==3;     % Verifica se tem chance nesta diagonal
      [vv,col]=max([A(3,1) A(2,2) A(1,3)]==0); % Verifica quadro que no foi marcado
      lin=-col+4;                         % Equao da reta
   end
   pode=(lin*col)>0;                      % Verifica se h chances de alinhamento
   if pode & encerra                      % Se h chance   para encerrar... AGE
      MA(lin,col)=1;                      % Registra jogada na matriz do jogo
      marca_x(lin,col,corx);              % Marca logo posio associada
   end;
%=============================================================
function circle(Xo,Yo,r);                 % Traa um crculo de raio r com centro em (Xo,Yo)
   n=1;
   for ang=0:2:360;
      pto(n,:)=[r*cos(ang/(2*pi))  r*sin(ang/(2*pi))];
      n=n+1; 
   end
   plot(Xo+pto(:,1),Yo+pto(:,2),'LineWidth',2,'Color','red');
%=============================================================
function marca_x(Xo,Yo,cor);              % Marca um X em Xo,Yo
   Xc=Xo-0.5; Yc=Yo-0.5;  % (Xc,Yc)= Ponto central do quadro selecionado
   plot([Xc-0.25 Xc+0.25],[Yc-0.25 Yc+0.25],'LineWidth',2,'Color','black');
   plot([Xc-0.25 Xc+0.25],[Yc+0.25 Yc-0.25],'LineWidth',2,'Color','black');
%==========================================================================================

% EOF JOGA_VELHA.M
