function [OutpatO,OutpatH]=nnout(WHI,WOH,BiasH,BiasO,Inppat)
% Assumindo: - apenas 1 camada escondida,
%            - sem ligacoes diretas entre as camadas de entrada e de saida,
%            - unidades escondidas e de saida usam funcao tangente hiperbolica.
% Inppat = vetor coluna com o padrao aplicado na camada de entrada
% OutpatH = vetor coluna com o padrao de saida da camada escondida
% OutpatO = vetor coluna com o padrao de saida da camada de saida
% Autores: Eduardo Botter e Cairo L. Nascimento Jr., cairo@ita.br, ITA
% Data: 22/Fev/1995, versao 1.0, Matlab 4.x
%       11/Fev/2002, versao 1.1, revisao para Matlab 5.3

NetH=WHI*Inppat+BiasH;
OutpatH=tanh(NetH);
NetO=WOH*OutpatH+BiasO;
OutpatO=tanh(NetO);

% EOF nnout.m


