% Programa MATLAB 4.x e 5.x - DEMOCR.M
% Metodo de treinamento: BP
% Programa valido apenas para 1 camada escondida
% Assumindo que unidades escondidas e de saida usam funcao
% tanh(x)= tangente hiperbolica
% Rotinas auxiliares: nnout.m, ord.m
% Notacao: MATRIZES: todas as letras maiusculas
%          VetoreS: todos sao vetores coluna
%                   apenas letras inicial e/ou final sao maiusculas
%          elementos: todas as letras minusculas
%
% Data: 31/Mar/1995, 6/Set/1995, 18/Fev/2002
% Autores: Cairo L. Nascimento Jr. - ITA - cairo@ita.br
%          Eduardo de Azevedo Botter 
% Revisao: 1.2

clear; close all;

% Matriz INPD = entrada dos padroes a serem aprendidos
% Cada padrao e' uma coluna
% numero de padroes = numero de colunas
% numero de unidades de entrada = numero de linhas

hexapat;  % define os 16 padroes hexadecimais usados para
          % treinamento da rede

% Descricao das variaveis globais
global iter npat nhid nout netah netao ninp netadec nord;

nhidf=8;        % numero de unidades escondidas
netah=0.2/20;   % learning rates para camadas de saida e escondida
netao=0.2/20;
netadec=0.0;    % decay rate
niter=200;      % numero de iteracoes de treinamento
ndisp=30;       % numero de epochs em cada iteracao de treinamento
nord=1;         % nord = 0, > 0 : ordenacao sequencial ou aleatoria
probflip=5/100; % probabilidade usada para controlar o nivel de ruido
                % adicionado nos padroes de entrada usados no treinamento
                % da rede neural
Nlevels=256;    % no. de niveis usados para a visualizacao grafica
                % Nlevels > 1
                
%rand('state',sum(100*clock));
%rand('state',5);
%gs=rand('state'); save good_seed gs;
load good_seed;
rand('state',gs);

% ninp = numero de unidades de entrada
% nout = numero de unidades de saida
% nhid = numero de unidades da camada escondida
% npat = numero de padroes a serem aprendidos pela rede
% netah, netao = learning rates
% niter = numero de iteracoes de treinamento

[ninp,npat]=size(INPD);
[nout,npat]=size(OUTD);

% o algoritmo sera estado para 6 , 8 e 12 unidades na camada escondida

nhidc=0;  % contador do loop para nhid, usado para mudar as cores
          % da curva de erro
hf(1)=figure(1); set(gcf,'Position',[  5  305   395   225]);
set(gcf,'DoubleBuffer','on'); % habilitar tracado mais rapido das linhas
                              % para mostrar animacoes em maquinas mais rapidas
hf(2)=figure(2); set(gcf,'Position',[  5  305   395   225]);
set(gcf,'DoubleBuffer','on');
hf(3)=figure(3); set(gcf,'Position',[405  305   395   225]);
set(gcf,'DoubleBuffer','on');
hf(4)=figure(4); set(gcf,'Position',[  5   33   395   200]);
set(gcf,'DoubleBuffer','on');
hf(5)=figure(5); set(gcf,'Position',[405   33   395   200]);
set(gcf,'DoubleBuffer','on');
hf(6)=figure(6); P3=get(hf(3),'Position'); set(gcf,'Position',P3);
set(gcf,'DoubleBuffer','on');

% Colormap for figure(2): -1 (white) : 1 (black)
MapOut=1-gray(Nlevels);  % size(MapOut) = [Nlevels,3]
% Colormap for figures 4 and 5:
% if x=max(abs(W)), then colormap is: -x(red) : 0(white) : x(green)
% size(MapW) = [2*Nl2-1,3]
Nl2=fix(Nlevels/2);                % Nlevels > 1, Nl2 >= 1
MapW(1:Nl2,:)=gray(Nl2);
MapW(1:Nl2,1)=ones([Nl2 1]);       % red scale (deep red to white)
MapW(Nl2:2*Nl2-1,:)=1-gray(Nl2);
MapW(Nl2:2*Nl2-1,2)=ones([Nl2 1]); % reverse green scale (white to deep green)
MapW(2*Nl2,:)=[0 0 0]; % define black color as the last color

for nhid=nhidf:nhidf;  % Loop para investigar o efeito do numero de unidades escondidas
    disp(' ');
    disp(['Rede neural sendo treinada com ' num2str(nhid) ' unidades escondidas ...']);
    nhidc=nhidc+1;  % incremento do contador para nhid
	 % nunits = numero total de unidades
	 nunits = ninp+nhid+nout;
	 % Matriz WHI = matriz de pesos entre as camadas de entrada e escondida
    % Matriz WOH = matriz de pesos entre as camadas escondida  e de saida
	 % BiasH e BiasO = vetores coluna com os bias das camadas escondidas e de
	 % saida
	 % notacao: W(i,j) = peso da unidade i vindo da unidade j
	 % os pesos recebidos por unidade i estao contidos na linha i
	 
	 % Geracao das matrizes de pesos e dos vetores de bias
	 WHI=2*rand(nhid,ninp)-1;
	 WOH=2*rand(nout,nhid)-1;
	 BiasH=2*rand(nhid,1)-1;
	 BiasO=2*rand(nout,1)-1;
        
	 % Define matriz MPLOT para mostrar as saidas da rede durante o aprendizado
	 % dim MPLOT=nhid+nout,npat 
	 % MPLOT = 1a. coluna com 1's, 2a. coluna com 2's,..., nouta. coluna com nout's
    %MPLOT=ones(nout,1)*[1:npat];
        
    % Labels for the axes of figures 1, 2, 4 and 5: XL1,YL1,XL2,YL2,XL4,YL4,XL5,YL5
    nhl1=fix(nhid/2);
    for i=1:nhl1; XL1(i)={['H' num2str(2*i)]}; end;  % X label for figure(1)
    nol1=fix(nout/2);
    for i=1:nol1; XL1(nhl1+i)={['O' hexastr(2*i)]}; end;
    if nhid ~= 2*fix(nhid/2); % if nhid is ODD
        for i=1:nol1; XL1(nhl1+i)={['O' hexastr(2*i-1)]}; end;
    end;
    % hexastr=['1234567890ABCDEF']; String defined in HEXAPAT
    npl=fix(npat/2);
    for i=1:npl; YL1(i)={['Pad' hexastr(2*i)]}; end; % Y label for figure(1)
    XL2=XL1; YL2=YL1;
    nil=fix(ninp/10);
    for i=1:nhid; XL4(i)={['H' num2str(i)]}; end;  % X label for figure(4)
    for i=1:nrow_img; YL4(i)={[num2str(i)]}; end;  % Y label for figure(4)
    XL5=XL4;                                       % X label for figure(5)
    XL5(nhid+1)={['BiasO']};
    nol=fix(nout/2);
    for i=1:nol; YL5(i)={['O' hexastr(2*i)]}; end;  % Y label for figure(5)
            
    % Loop das iteracoes de treinamento
    for iter=0:niter;
        % loop para treinar a rede
        if iter > 0;
           for idisp=1:ndisp; % ndisp = no. de epochs de treinamento em cada iteracao
               % Adicionar ruido do tipo flip-flop nos padroes de entrada
               % usados para treinar a rede
               [INPD2,INPD2C]=flip(INPD,probflip);
               % Chamada da rotina Back Propagation
	            [WHI,WOH,BiasH,BiasO]=bpc(WHI,WOH,BiasH,BiasO,INPD2,OUTD);
           end;
        end; % end "if iter > 0;"    
        
	     % Calculo do erro nesta iteracao
	     [errop,OutpatO,OutpatH]=calcer(WHI,WOH,BiasH,BiasO,INPD,OUTD);
	     erro(iter+1,1)=errop;
        % Verifica quais unidades estao com erro acima do limite
        UE=[];
        for ipat=1:npat;
           if max(abs((OUTD(:,ipat)-OutpatO(:,ipat))/2)) > 0.35;
              UE=[UE; ipat];
           end;
        end;
        % Calculo do numero de padroes classificados de forma errada
        nerros=sum(max(abs((OUTD-OutpatO)/2))>0.35);
        fprintf('\n Iterao = %g, RMS Erro = %s, Nerros = %g', ...
                 iter, num2str(errop), nerros);
        if length(UE) > 0;
           fprintf(': Unidades = ['); fprintf(' %g',UE); fprintf(']');
        end;
        % vetor que armazena o numero de erros ao final desta iteracao
        VE(iter+1,2)=nerros;         VE(iter+1,1)=iter;
        
	     % Visualizacao grafica das saidas durante a aprendizagem
        if iter ==0; figure(1); else; figure(2); end;
        OutpatHO=[OutpatH', OutpatO'];
        miny=-1; maxy=1;
        colormap(MapW); % size(MapW) = [2*Nl2-1,3] + last row = black
        OutImage=(OutpatHO-miny)*((2*Nl2-1-1)/(maxy-miny))+1;
        image(OutImage);
        set(gca,'XTick',[2:2:nhid, nhid+(2:2:nout)]);
        if nhid ~= 2*fix(nhid/2); % if nhid is ODD
           set(gca,'XTick',[2:2:nhid, nhid+(1:2:nout)]);
        end;
        set(gca,'XTickLabel',XL2);
        set(gca,'YTick',2*[1:npl]);
        set(gca,'YTickLabel',YL2);    
        xlabel('Tipo e No. da Unidade');
        ylabel('No. do padro de entrada');
        title(['Iterao = ' num2str(iter) ', rmsE = ' num2str(errop) ...
               ', PFlip = ' num2str(100*probflip) '%, NE = ' num2str(nerros)]);
        grid; drawnow;
         
        % Visualizacao grafica da curva com o numero de erros
        figure(3);
        [Vex,Vey]=stairs(VE(:,1),VE(:,2));
        plot(Vex,Vey); axis([0 iter+1 0 17]);
        xlabel('No. da iterao');
        ylabel('No. de erros');
        title('Curva do no. de erros p/ padres sem rudo');
        grid;
        
        % Mostrar os pesos recebidos pelas unidades nas camadas escondidas
        figure(4);
        colormap(MapW); % size(MapW) = [2*Nl2-1,3] + last row = black
        ncol2=ncol_img+1;  % nrow_img & mncol_img were defined in HEXAPAT
        maxy=max(max(abs([WHI,BiasH])));
        miny=-maxy;
        for ih=1:nhid;
            for ir=1:nrow_img;                
                Outaux(ir,1:ncol_img)=WHI(ih,(ir-1)*ncol_img+1:ir*ncol_img);
            end;
            Outaux(1:nrow_img,ncol2)=[BiasH(ih);zeros([nrow_img-1,1])];
            % size(Outaux) = nrow_img, ncol_img+1
            Outaux=(Outaux-miny)*((2*Nl2-1-1)/(maxy-miny))+1; % normalization [1 2*Nl2-1]
            Outaux(2:nrow_img,ncol2)=2*Nl2*ones([nrow_img-1,1]);
            OutImage2(1:nrow_img,(ih-1)*ncol2+1:ih*ncol2)=Outaux;
        end;
        image(OutImage2); 
        set(gca,'XTick',[fix(ncol_img/2)+1:ncol_img+1:nhid*(ncol_img+1)]);
        set(gca,'XTickLabel',XL4);
        set(gca,'YTick',1:nrow_img);
        set(gca,'YTickLabel',YL4);
        xlabel('No. da unidade escondida');
        ylabel('Linha do padro de entrada');
        title('Pesos entre as camada de entrada e escondida');
        drawnow;
        % Mostrar os pesos recebidos pelas unidades na camada de saida
        figure(5);
        maxy=max(max(abs([WOH,BiasO]))); miny=-maxy;
        colormap(MapW);
        OutImage=([WOH,BiasO]-miny)/(maxy-miny);
        OutImage=OutImage*(2*Nl2-1-1)+1;
        image(OutImage);
        set(gca,'XTick',1:(nhid+1));
        set(gca,'XTickLabel',XL5);
        set(gca,'YTick',2*[1:nol]);
        set(gca,'YTickLabel',YL5);
        title('Pesos entre as camada escondida e de sada');
        xlabel('No. da unidade escondida');
        ylabel('No. da unidade de sada');
        drawnow;
        %
        if iter == 0;
           disp(' '); disp('Pausing ...'); pause(2);
           disp('... Out of pause');
        end;
                
    end; % end "for iter=0:niter;"
    
	 % Mostre curva de aprendizado
    P3=get(hf(3),'Position');
    figure(6);
    set(gcf,'Position',P3);
    set(gcf,'DoubleBuffer','on');

    % plote a curva de aprendizado em diferentes cores
    % de acordo com o numero de unidades escondidas
    niterf=length(erro)-1;   % definir niterf p/ caso onde treinamento foi interrompido
    if nhidc == fix(nhidc/4)*4+1;
	    semilogy([0:niterf],erro,'red');
    end;
    if nhidc == fix(nhidc/4)*4+2;
	    semilogy([0:niterf],erro,'c');
    end;
    if nhidc == fix(nhidc/4)*4+3;
	    semilogy([0:niterf],erro,'g');
    end;
    if nhidc == fix(nhidc/4)*4;
	    semilogy([0:niterf],erro,'black');
    end;
    %
	 axis([0 niterf 0 fix(max(erro))+1]);
	 xlabel('No. de iteraes');
	 ylabel('Erro Quadrtico Mdio');
	 title('Curva de Aprendizado'); grid;
	 hold on;  % hold on para sobrepor proximas curvas de aprendizado
    
end; % end "for nhid=nhidf:nhidf;"

hold off; disp(' ');
clear INPD2C;  % INPD2C usada por rotina flip.m

save democr;

%To helpto study the input patterns use
%for i=1:npat;
% fprintf('%1.0f%1.0f%1.0f%1.0f%1.0f%1.0f%1.0f\n',0.5*INPD(:,i)'+0.5);
%end;
% 

% EOF DEMOCR.M
