% Programa DSPHEX.M
% Programa MATLAB (4,5 e 6) para mostrar os 16 padroes hexadecimais
% com ruido uniforme adicionado em cada pixel.
% Cada pixel tem probabilidade PROBFLIP de mudar de sinal.
% Autor: Cairo L. Nascimento Jr - ITA - cairo@ita.br
% Data:  6/Set/1995, versao inicial
%       15/Fev/2002, adicao do botao STOP e rearranjo do loop de imagens
% Revisao: 1.2

close all;

% HEXAPAT retorna matrizes com os caracteres 0-9, A-F com elementos 0 e 1.
% FLIP inverte o valor do pixel de acordo com a probabilidade dada
% por PROBFLIP e retorna matrizes B (padrao com ruido) e C (indicacao
% dos pixels que mudaram de sinal).

probflip=-1;
while probflip < 0 | probflip > 100;
      % probabilidade de cada pixel mudar de sinal
      probflip=input('Definir nvel de rudo nas imagens [0-100] (%): ');
end;
probflip=probflip/100;
hexapat; figure(1); clf;

opt=0;
opt=1;  % se opt > 0, nao usar diferentes cores para
        % representar os pixels que mudaram de sinal
        % ou seja: -1+ruido:cor(1)
        %          +1+ruido:cor(-1)
% Define um novo colormap
colormap(gray(80)); map=colormap;
% pixel -1: cor amarela; pixel 1: cor cinza
% pixel -1 --> cmap 1, pixle 1 --> cmap 79
% pixel -1+flip --> 2, 1+ruido --> 80
map( 1,:)=[1 0.675 0];      % amarelo  (-1)
map( 2,:)=[1 1 1];          % branco   (-1+ruido)
map(79,:)=[0.5 0.5 0.5];    % cinza    (+1)
map(80,:)=[0 0 0];          % black    (+1+ruido)
% Outras cores [rgb]:
% red = [1 0 0], green = [0 1 0], blue = [0 0 1]
% azul claro = [0 1 0.925]
if opt>0;
   map(2,:)=map(1,:); map(80,:)=map(79,:);
end;
colormap(map); axis('square');

% Matrizes INPDx contem apenas 0 e 1.
% B contem matriz resultante e C indica quais pixels mudaram de sinal.
% B contem -1 e 1. C contem 0 e 1.
% Assim: 
% INPDx(i,j)         Imagem(i,j)
%    0   ---> -1 --->   1 (se nao mudou de sinal) OU
%                --->   2 (se mudou de sinal)
%    1   --->  1 --->  79 (se nao mudou de sinal) OU
%                --->  80 (se mudou de sinal)

% Preparacao do botao STOP
% A simulacao e' interrompida ao ser pressionado o botao STOP
% visto que a funcao callback faz "UserData=0" e o valor de "UserData"
% e' sempre carregado em "flag"
hs = uicontrol(gcf, 'style', 'pushbutton','string','STOP',...
     'callback', 'set(gcf, ''UserData'', 0)');
flag = 1;
set(gcf, 'UserData', flag);

hexastr=['1234567890ABCDEF'];
in=1;

while flag;
      eval(['[B,C]=flip(2*INPD' num2str(hexastr(in)) '-1,probflip);']);
      image(39*B+40+C);
      title(['Padro ' num2str(hexastr(in))  ...
              ', Nvel de rudo = ' num2str(probflip*100) ' %']);
      drawnow;
      pause(1);
      flag = get(gcf, 'UserData');
      in=in+1; if in>16; in=1; end;
end;

% EOF DSPHEX.M
