function [OutpatO,OutpatH]=nnout(WHI,WOH,BiasH,BiasO,Inppat)
% Assumindo: - apenas 1 camada escondida,
%            - sem ligacoes diretas entre as camadas de entrada e de saida,
%            - unidades escondidas e de saida usam funcao tangente hiperbolica.
% Inppat  = vetor coluna com o padrao de entrada da rede
% OutpatH = vetor coluna com a saida de cada unidade escondida
% OutpatO = vetor coluna com o padrao de saida da rede
%
% Autores: Eduardo Botter e Cairo L. Nascimento Jr. - ITA - cairo@ita.br
% Data: 22/Fev/1995, Matlab 4.x e 5.x
%       10/Fev/2002, Revisao

NetH=WHI*Inppat+BiasH;
OutpatH=tanh(NetH);
NetO=WOH*OutpatH+BiasO;
OutpatO=tanh(NetO);

% EOF nnout.m


