function [B,ordpat2]=ord(A);
% Funcao para reordenar as colunas de uma matriz A em uma ordem
% aleatoria. A matriz B contem a nova matriz reordenada e
% e vetor linha ordpat2 contem os indices da nova ordenacao.
% Dimensoes: se dim A = N,M; dim B = N,M e dim ordpat2 = 1,M 
% Autor: Cairo L. Nascimento Jr.
% Data: 22 Fev 95
% Versao: 1.0

[nlin,npat]=size(A);
ordpat=[1:npat]';

% Ideia basica: criar 2 pilhas, move-se os elementos da
% pilha 1 para pilha 2

for iord=1:npat-1;
    % iord2 = elemento a ser retirado da pilha 1
    iord2=fix(rand*(npat-iord+1))+1;
    % coloque na pilha 2 o elemento retirado da pilha 1
    ordpat2(iord,1)=ordpat(iord2,1);
    % coloque na pilha 1 zero no lugar do elemento retirado
    ordpat(iord2,1)=0;
    % encolha a pilha 1; fim da pilha 1 = npat-iord+1
    if iord2 < npat-iord+1;
       ordpat(iord2:npat-iord,1)=ordpat(iord2+1:npat-iord+1,1);
    end;
    % coloque zeros no fim da pilha
    %ordpat(npat-iord+1:npat,1)=zeros(iord,1);
    ordpat(npat-iord+1,1)=0;
    %iord2, ordpat', ordpat2', pause;
end;
ordpat2(npat,1)=ordpat(1,1);
ordpat(1,1)=0;
%ordpat', ordpat2',

for icol=1:npat;
    B(:,icol)=A(:,ordpat2(icol,1));
end;

% define como vetor linha para facilitar visualizacao,
% ja'que a ordenacao e'por colunas.
ordpat2=ordpat2';

% EOF ord.m
