% Programa MATLAB 4.x TESTGEN.M
% M-File used to test the generalization of the NN, 1 hidden layer
% Dados de entrada: parametros da rede (WHI,WOH,BiasH,BiasO)
%                   padroes de entrada sem ruido (INPD)
%                   saidas desejadas (OUTD)
%                   tipo das saidas da rede (nettype)
%                   limiar usado para declarar MISCLASSIFICATION (limiar)
%                   niveis de ruido usados para teste (Vprob)
% Dados de saida:   taxas de acerto (TEST(:,4))

% Autor: Cairo L. Nascimento Jr. - ITA - cairo@ita.cta.br
% Data: 10/Ago/1995 (1.0), 7/Sep/1995 (1.1)
% Revisao: 1.1

% Rodar este arquivo depois da rede neural estar treinada

Vprob=-1;
while Vprob < 0 | Vprob > 100;
      % probabilidade de cada pixel mudar de sinal
      Vprob=input('Nvel de rudo para teste (%)? ex. [0:5:50]: ');
end;
Vprob=Vprob/100;

if Vprob <= 0 | Vprob > 1;
   Vprob=0;
   ntests=1;
else;
   ntests=0;
   while ntests <= 0;
      % ntests = numero de amostras para cada padrao
      ntests=input('Numero de amostras para cada padro ? ex. 50: ');
   end;
end;

%Vprob=[0:5:15]/100;      % taxas de ruido usadas para testar a rede
%ntests=100;

limiar=0.35;             % Limiar usado para declarar MISCLASSIFICATION
                         % considerando saidas no intervalo [0,1]
nettype=2;               % Se saidas no intervalo  [0,1], nettype=1;
                         % Se saidas no intervalo [-1,1], nettype=2;

hexastr=['1234567890ABCDEF'];
disp(' ');
disp('Testando a generalizacao da rede neural ...');
ntests0=ntests;

clear TEST;  % limpar matriz TEST caso testes anteriores foram executados
for iprob=1:length(Vprob);
    %rand('seed',iprob); rand('uniform');
    icount=0;     % numero de padroes "misclassified"
    icountOK=0;   % numero de padroes classificados corretamente
    disp(' ');
    disp(['Erros por padrao, Erros totais, Acertos Totais, PFlip = ',num2str(Vprob(iprob)*100),' %']);
    
    for ipat=1:npat;
        icountp=0;  % contador para apenas este padrao
        ntests=ntests0;
        if Vprob(iprob) <= 0; ntests=1; Vprob(iprob)=0; end;
        if Vprob(iprob) >  1; Vprob(iprob)=1; end;
        [INPDTG,INPDTGC]=flip(INPD(:,ipat)*ones(1,ntests),Vprob(iprob));
        % WARNING: Possivel problema de memoria se ntests for muito grande
        % 2 matrizes de dimensao npat,ntestes
        % Neste caso trocar os loops de posicao ipat e itest e alterar a impressao dos calculos
        for itest=1:ntests;
            Inppat=INPDTG(:,itest);
            % funcao NNOUT assume que a rede usa funcoes tangente hiperbolica
            [Outpat,OutH]=nnout(WHI,WOH,BiasH,BiasO,Inppat);
            % Erro = d-y. Mapeando saidas de [-1,1] para [0,1], temos
            % Erro = (d'+1)/2 - (y'+1)/2 = (d'-y')/2
            Verro=(OUTD(:,ipat)-Outpat)/nettype;
            % Outpat, Verro,
            % Se saidas desejadas e saida da rede estiverem em [0,1]:
            % entao usar: erro=OUTD(:,ipat)-Outpat;
            if max(abs(Verro)) > limiar;
               icount=icount+1; icountp=icountp+1;
            else;
               icountOK=icountOK+1;
            end;
        end;
        fprintf('Teste padrao %s = %g %g %g\n', hexastr(ipat), icountp, icount, icountOK);
    end;
    % 4a coluna de TEST contem as taxas de acerto
    disp('Pflip (%), Erros Totais, Acertos Totais, Taxa de acerto (%)');
    TEST(iprob,:)=[100*Vprob(iprob) icount icountOK 100*icountOK/(icount+icountOK) ];
    fprintf('TEST %g --> %5.3f %6i %6i   %6.4f \n',iprob,TEST(iprob,1:4));
end;

if length(Vprob) > 1;
   figure; clf;
   set(gcf,'Position',[7    34   792   196]);
   set(gcf,'DoubleBuffer','on');
   plot(TEST(:,1),TEST(:,4));
   axis([-inf inf 0 100]); grid; hold on;
   plot(TEST(:,1),TEST(:,4),'*');
   set(gca,'XTick',Vprob*100);
   xlabel('Nvel de Rudo (%)');
   ylabel('Taxa de Acerto (%)');
   title('Teste de Generalizao');
   hold off;
   %print -dmeta acerto;
end;

clear INPDTG INPDTGC % matrizes usada pela rotina FLIP.M
disp(' ');

% EOF TESTGEN2.M
