% Programa DSPHEXA2.M
% Programa MATLAB 4.x para mostrar os 16 padroes hexadecimais
% com ruido uniforme adicionado em cada pixel.
% Cada pixel tem probabilidade PROBFLIP de mudar de sinal.
% Data: 6/Sep/95
% Autor: Cairo L. Nascimento Jr - ITA - cairo@ita.cta.br
% Revisao: 1.1

% HEXAPAT retorna matrizes com os caracteres 0-9, A-F com elementos 0 e 1.
% FLIP2 inverte o valor do pixel de acordo com a probabilidade dada
% por PROBFLIP.
% FLIP2 retorna matrizes B (padrao com ruido) e C (indicacao dos pixels
% que mudaram de sinal).


probflip=-1;

while probflip < 0 | probflip > 100;
      % probabilidade de cada pixel mudar de sinal
      probflip=input('Enter noise level [0,100] (%): ');
end;
probflip=probflip/100;

opt=0;
opt=1;  % se opt > 0, nao usar diferentes cores para
        % representar os pixels que mudaram de sinal
        % ou seja: -1+ruido:cor(1)
        %          +1+ruido:cor(-1)

disp('Press CTRL-C to stop this demo ... ');
disp('Press ENTER  to display next image ...'); 
%disp('Press   Q    to stop ...');

hexapat; figure(1); clf;

% Define um novo colormap
colormap(gray(80)); map=colormap;
% pixel -1: cor amarela; pixel 1: cor cinza
% pixel -1 --> cmap 1, pixle 1 --> cmap 79
% pixel -1+flip --> 2, 1+ruido --> 80
map( 1,:)=[1 0.675 0];      % amarelo  (-1)
map( 2,:)=[1 1 1];          % branco   (-1+ruido)
map(79,:)=[0.5 0.5 0.5];    % cinza    (+1)
map(80,:)=[0 0 0];          % black    (+1+ruido)
% Outras cores [rgb]:
% red = [1 0 0], green = [0 1 0], blue = [0 0 1]
% azul claro = [0 1 0.925]

if opt>0;
   map(2,:)=map(1,:); map(80,:)=map(79,:);
end;

colormap(map); axis('square');

% Matrizes INPDx contem apenas 0 e 1.
% B contem matriz resultante e C indica quais pixels mudaram de sinal.
% B contem -1 e 1. C contem 0 e 1.
% Assim: 
% INPDx(i,j)         Imagem(i,j)
%    0   ---> -1 --->   1 (se nao mudou de sinal) OU
%                --->   2 (se mudou de sinal)
%    1   --->  1 --->  79 (se nao mudou de sinal) OU
%                --->  80 (se mudou de sinal)
while 1 ==1;
    [B,C]=flip2(2*INPD0-1,probflip); image(39*B+40+C); title('Padrao 0'); xlabel(['Noise level = ',num2str(probflip*100),' %']); pause;
    [B,C]=flip2(2*INPD1-1,probflip); image(39*B+40+C); title('Padrao 1'); xlabel(['Noise level = ',num2str(probflip*100),' %']); pause;
    [B,C]=flip2(2*INPD2-1,probflip); image(39*B+40+C); title('Padrao 2'); xlabel(['Noise level = ',num2str(probflip*100),' %']); pause;
    [B,C]=flip2(2*INPD3-1,probflip); image(39*B+40+C); title('Padrao 3'); xlabel(['Noise level = ',num2str(probflip*100),' %']); pause;
    [B,C]=flip2(2*INPD4-1,probflip); image(39*B+40+C); title('Padrao 4'); xlabel(['Noise level = ',num2str(probflip*100),' %']); pause;
    [B,C]=flip2(2*INPD5-1,probflip); image(39*B+40+C); title('Padrao 5'); xlabel(['Noise level = ',num2str(probflip*100),' %']); pause;
    [B,C]=flip2(2*INPD6-1,probflip); image(39*B+40+C); title('Padrao 6'); xlabel(['Noise level = ',num2str(probflip*100),' %']); pause;
    [B,C]=flip2(2*INPD7-1,probflip); image(39*B+40+C); title('Padrao 7'); xlabel(['Noise level = ',num2str(probflip*100),' %']); pause;
    [B,C]=flip2(2*INPD8-1,probflip); image(39*B+40+C); title('Padrao 8'); xlabel(['Noise level = ',num2str(probflip*100),' %']); pause;
    [B,C]=flip2(2*INPD9-1,probflip); image(39*B+40+C); title('Padrao 9'); xlabel(['Noise level = ',num2str(probflip*100),' %']); pause;
    [B,C]=flip2(2*INPDA-1,probflip); image(39*B+40+C); title('Padrao A'); xlabel(['Noise level = ',num2str(probflip*100),' %']); pause;
    [B,C]=flip2(2*INPDB-1,probflip); image(39*B+40+C); title('Padrao B'); xlabel(['Noise level = ',num2str(probflip*100),' %']); pause;
    [B,C]=flip2(2*INPDC-1,probflip); image(39*B+40+C); title('Padrao C'); xlabel(['Noise level = ',num2str(probflip*100),' %']); pause;
    [B,C]=flip2(2*INPDD-1,probflip); image(39*B+40+C); title('Padrao D'); xlabel(['Noise level = ',num2str(probflip*100),' %']); pause;
    [B,C]=flip2(2*INPDE-1,probflip); image(39*B+40+C); title('Padrao E'); xlabel(['Noise level = ',num2str(probflip*100),' %']); pause;
    [B,C]=flip2(2*INPDF-1,probflip); image(39*B+40+C); title('Padrao F'); xlabel(['Noise level = ',num2str(probflip*100),' %']); pause;
end;

% EOF DSPHEXA2.M
